<?php
class form_editor {
	
	function __construct(){

	}
	
	public function displayeditor() {      
	   
	  $this->plugin_url = 'form_editor';
	  $this->dir_name = dirname(__FILE__);
	  //$this->template_css_ui = $this->scanFolder(dirname(__FILE__).'/css/ui/', 'FOLDERS');
	  //$this->template_css = $this->scanFolder(dirname(__FILE__).'/css/w2_contact_form/', 'FOLDERS');
      
	  $this->template_files = $this->scanFolder(dirname(__FILE__).'/templates/fields/', 'FILES');
	  $this->container_html = $this->getIncludeContents(dirname(__FILE__) . '/templates/container.php');
	  
	   $output = $this->getIncludeContents(dirname(__FILE__) . '/includes/form_editor.php');	
	   echo $output;
	   
	}
	
	public function createhtmlsourcefile() {
    
		
		$valuesPost = $this->validForm($_POST, array('css_theme', 'css_ui_theme', 'reset_form', 'attachment_file', 'max_attachment_files', 'no_spam_control', 'no_spam_control_type', 'recaptcha_theme', 'recaptcha_lang', 'reload_captcha', 'ayah', 'show_btn_send', 'custom_file_input', 'submit_alert_type', 'att_alert_type'));
		
		if(is_array($valuesPost)) {

			$valuesPost['html_template'] = $_POST['html_template'];
			
			$infos = '';
			if(isset($_POST['custom_template']) && $_POST['custom_template'] == 1) {
			  $valuesPost['css_theme'] = 'mycustom';
			  $infos = '<!-- Your custom css has been added - read the installation instruction in the custom CSS file that you have downloaded -->';
			}
			
			$document_html = $this->getIncludeContents(dirname(__FILE__) . '/templates/document.php');
			$document_html = str_replace(array('[infos]', '[css_theme]', '[css_ui_theme]'), array($infos, $valuesPost['css_theme'], $valuesPost['css_ui_theme']), $document_html);
		
			
			//for production  
			if(isset($valuesPost['re_captcha']) && $valuesPost['re_captcha'] != '')
			  $valuesPost['re_captcha'] = $valuesPost['re_captcha'];
			else
			  $valuesPost['re_captcha'] = 'null';
			
			
	   
			$document_html = str_replace(array('[opt_no_spam_control]', '[opt_no_spam_control_type]', '[opt_reset_form]', '[opt_attachment_file]', '[opt_max_attachment_files]', '[opt_show_btn_send]', '[opt_custom_file_input]', '[opt_submit_alert_type]', '[opt_att_alert_type]', '[opt_re_captcha]', '[opt_recaptcha_theme]', '[opt_recaptcha_lang]', '[opt_reload_captcha]', '[opt_ayah]'), array($valuesPost['no_spam_control'], $valuesPost['no_spam_control_type'], $valuesPost['reset_form'], $valuesPost['attachment_file'], $valuesPost['max_attachment_files'], $valuesPost['show_btn_send'], $valuesPost['custom_file_input'], '"'.$valuesPost['submit_alert_type'].'"', '"'.$valuesPost['att_alert_type'].'"', '"'.$valuesPost['re_captcha'].'"', '"'.$valuesPost['recaptcha_theme'].'"', '"'.$valuesPost['recaptcha_lang'].'"', $valuesPost['reload_captcha'], $valuesPost['ayah']), $document_html);
			
			$container_html = $this->getIncludeContents(dirname(__FILE__) . '/templates/container.php');
			$container_html = str_replace('[fields_zone]', $valuesPost['html_template'], $container_html);
			
			$document_html = str_replace('[form_container]', $container_html, $document_html);
		
			header("Content-disposition: attachment; filename=template.html"); 
			header("Content-Type: application/force-download"); 
			//header("Content-Transfer-Encoding: $type\n"); // Surtout ne pas enlever le \n 
			header("Pragma: no-cache"); 
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0, public"); 
			header("Expires: 0"); 
			
			echo $document_html;
		}
		else
		  echo "Error";
	   
	}
	
	public function createcsssourcefile() {
    
		
		$valuesPost = $this->validForm($_POST, array('add_css', 'customed_css_img_dir'));
		
		if(is_array($valuesPost)) {

			$document_css = $this->getIncludeContents(dirname(__FILE__) . '/templates/mycustom.php');
			
			$infos = "/*********************************** \n Your custom CSS \n Installation: \n - include this file in the folder w2_acf/css/w2_contact_form/mycustom/ (replace the custom.css existant) \n - images package used with your custom css = ".$valuesPost['customed_css_img_dir']." (replace this img folder w2_acf/css/w2_contact_form/mycustom/img/ folder  by  the  w2_acf/css/w2_contact_form/".$valuesPost['customed_css_img_dir']."/img/  folder ) \n ***********************************/";
			
			$document_css = str_replace(array('[infos]', '[css]'), array($infos, $valuesPost['add_css']), $document_css);

			header("Content-disposition: attachment; filename=custom.css"); 
			header("Content-Type: application/force-download"); 
			//header("Content-Transfer-Encoding: $type\n"); // Surtout ne pas enlever le \n 
			header("Pragma: no-cache"); 
			header("Cache-Control: must-revalidate, post-check=0, pre-check=0, public"); 
			header("Expires: 0"); 
			
			echo $document_css;
		}
		else
		  echo "Error - your custom css is empty.";
	   
	}

	public function getIncludeContents($filename) {
		if (is_file($filename)) {
			ob_start();
			include $filename;
			return ob_get_clean();
		}
		return false;
    }
	
	public function advScanDir( $dir, $mode )
	{
	 
		 // creation du tableau qui va contenir les elements du dossier
		 $items = array();
		 // ajout du slash a la fin du chemin s'il n'y est pas
		 if( !preg_match( "/^.*\/$/", $dir ) ) $dir .= '/';
		 // Ouverture du repertoire demande
		  $handle = opendir( $dir );
		 // si pas d'erreur d'ouverture du dossier on lance le scan
		 if( $handle != false )
		 {
		  // Parcours du repertoire
		  while( $item = readdir($handle) )
		  {
		   if($item != '.' && $item != '..')
		   {
			// selon le mode choisi
			switch( $mode )
			{
			 case 'FOLDERS' :
			  if( is_dir( $dir.$item ) )
			   $items[] = $item;
			 break;
			 case 'FILES' :
			  if( !is_dir( $dir.$item ) )
			   $items[] = $item;
			 break;
			 case  'ALL' :
			  $items[] = $item;
			
			}
		   }
		  }
		  
		  // Fermeture du repertoire
		  closedir($handle);
		   
		  return $items;
		  
		 }
		 else 
		    return false;
	  
	}
 
	public function scanFolder ($folder, $mode)
	{	 
	   $filesReturn = array();
	   $filesEnter = array();
	   $filesEnter = $this->advScanDir( $folder, $mode );
	   foreach( $filesEnter as $value )
	   {
			 $file_name = $value;
			 $url_file = $folder.$value;
			 $filesReturn[$file_name] = $url_file;
			  
	   }
	   return $filesReturn;
	}
	
	public function stringToBoolean($value) {
	  if($value == 'false')
		$value = false;
	  else if($value == 'true')
		$value = true;
		
	  return $value;
   }
   
   public function validForm ($valuesPost, $required, $escapeHtml = array()){
          
		  $validForm = true;
		  $values = array();
		  
		  $postKeys = array_keys($valuesPost);
		  foreach ($required as $value) {
			  if(!in_array($value, $postKeys))
				$validForm = false;
		  }

		  if($validForm) {
			  foreach ($valuesPost as $key => $value) {
				  if(in_array($key, $required) && $value == "")
					$validForm = false;
				  
				  if (in_array($key, $escapeHtml))
					$values[$key] = $this->escapeInHTML ($value);
				  else {
					if(!is_array($value))
					  $values[$key] = $this->escapeIn ($value);
					else
					  $values[$key] = $value;
				  }
			  }
		  }
		  
		  if($validForm)
		     return $values;
		  else
		     return false;
	}
   
   public function escapeIn ($string)
	{
		//$string = mysql_real_escape_string($string);
		$string = htmlspecialchars($string);
		$string = trim ($string);
		return $string; 
	}
	
	public function escapeInHTML ($string)
	{   
	    $string = htmlspecialchars_decode($string);
		//$string = mysql_real_escape_string($string);
		$string = trim ($string);
		return $string; 
	}
	
	public function escapeOutHTML ($string)
	{   
		$string = stripslashes($string);
		$string = trim ($string);
		return $string; 
	}

	
}


if (class_exists('form_editor')) {
   $form_editor = new form_editor();
}

if(isset($_POST['action'])) {
	$action = $_POST['action'];
	$form_editor->$action();
}
if(isset($_GET['action'])) {
	$action = $_GET['action'];
	$form_editor->$action();
}

?>