<?php
/***************************
*                          *
*        Treatment         *
*                          *
***************************/

//include the PHP Class w2ContactForm
//for the first use don't forget to specify your own encryption key for no spam control (file: "w2_acf/w2ContactForm.php")
require_once('w2ContactForm.php');


//a form is submited 
if(isset($_POST) && !empty($_POST)){	
  
  
  //creation of a new instance of Class Contact
  $contact = new W2ContactForm();
  //Specifies the emails sender. If you don't specifie email sender the email used to send the mail will be the user mail (who submit the form)
  $contact->setMailSender('no-reply@mywebsite.net');
  //Specifies the emails recipients. You can specifies several emails for multiple recipient. If only one email is specifie the default email will be the first (index 1)
  $contact->setMailRecipient(array('1' => 'youremail1@mail.net', '2' => 'youremail2@mail.net'));
  //Specifies if you want to use auto responder feature  
  $contact->setAutoResponder(true);
  //Specifies if you want to use an email different that email sender to the auto responder
  $contact->setMailResponder('no-reply2@mywebsite.net');
  
   
  //internationnalization with simple .tmx file (laguages/w2_cf_notifications.tmx)
  $contact->setLang('en');
  
  //Use this code only if you need to send email via SMTP
  //For SMTP sending - specify your own SMTP HOST (generally "smtp.domaine.com" - use "localhost" for Hosted Dedicated Server)
  //Basic example
  /*$contact->setSmtpHost('smtp.domaine.com');*/
  
  //Example for gmail config (openSSL must be installed in your server to send mail via gmail smtp)
  /*$config = array('ssl' => 'tls', 
			      'port' => 587,
				  'auth' => 'login', 
				  'username' => 'username@gmail.com', 
				  'password' => 'password');
  $contact->setSmtpHost('smtp.gmail.com', $config);*/
  
  $contact->setNoSpamControl(true);
  $contact->setMaxAttachmentFiles(5);
  $contact->setRequiredFields(array('recipient', 'mail', 'subject', 'message'));
  $contact->setBodyMessageFields('<p>E-mail: [mail]</p><p>Message: [message]</p>');

  
  //Sending email	 
  $contact->sendEmail();




  
    /*************************************************
	*                                                *
	*        Example of a full configuration         *
	*                                                *
	*************************************************/
  
  /*
  //if you need to redefine some parameters (example: if you have several contact form in your web site)
  //Specifies the emails sender. If you don't specifie email sender the email used to send the mail will be the user mail (who submit the form)
  $contact->setMailSender('no-reply@mywebsite.net');
  ///Specifies the emails recipients. You can specifies several emails for multiple recipient. If only one email is specifie the default email will be the first (index 1)
  $contact->setMailRecipient(array('1' => 'youremail@mail.net', '2' => 'youremail2@mail.net'));
  //Specifies if you want to use auto responder feature  
  $contact->setAutoResponder(true);
  //Specifies if you want to use an email different that email sender to the auto responder
  $contact->setMailResponder('no-reply2@mywebsite.net');
  //Specifies the attachment files for responder (if you need) - you need to send your attachement file in your server in the folder "w2_acf/uploads/responder/" before to use this method
  $contact->setResponderAtt(array('my_attachemnt.pdf', 'my_attachemnt_2.pdf'));
  //Specifies the name of your web site
  $contact->setSiteName('name of web site');
  //Specifies the required fields for the form validation.
  $contact->setRequiredFields(array('recipient', 'mail', 'subject', 'message'));
  //Specifies the fields for adding them in the mail body message (exammple:  array('mail' => 'E-mail', 'message' => 'Message')) - if you don't specifie field all the fields will be automatically added to the mail body message
  $contact->setBodyMessageFields(array('mail' => 'E-mail', 'phone' => 'Phone number', 'country' => 'Country', 'version' => 'Version', 'website' => 'Web site', 'message' => 'Message'));
  //Specifies the subject of the email if you don't use subject field in your form
  $contact->setMailSubject = 'subject of the message';
  //Specifies the fields need HTML encodage (example: textarea)
  $contact->setHtmlFields(array('message'));
  //Specifies if HTML tags is accepted in the email message (for the textarea form element)
  $contact->setAcceptHtmlContent(false);
  //Specifies the folder for uploads attachments files in your server
  $contact->setUploadsFolder(dirname(__FILE__).'/uploads');
  //Specifies the max file size for the attachments files (in octet)
  $contact->setMaxFileSize(1000000);
  //Specifies the maximum number for attachments files
  $contact->setMaxAttachmentFiles(5);
  //Specifies the accepted extensions (.jpg, .png, .pdf ...) for the attachments files
  $contact->setExtFileOk(array('pdf', 'doc', 'docx', 'jpeg', 'jpg', 'png', 'gif'));
  //Specifies if you want to delete files uploaded after email sending
  $contact->setDeleteUploadsAfterSending(true);
  //Specifies the minimum and the maximum time between submission of the form (in seconds)
  $contact->setAntiSpamTimeControl(array('min' => '5', 'max' => '3600'));
  //Specifies if you want the script configure the CHMOD for "uploads" folder
  $contact->setAutoCHMOD(false);
  //Specifies if you want to use no spam control (drag and drop)
  $contact->setNoSpamControl(true);
  //Specifies if you want to use recaptcha for validation form
  $contact->setReCaptcha(false);
  //Specifies if you want to use AYAH for validation form
  $contact->setAyah(false);
  //internationnalization with simple .tmx file (laguages/w2_cf_notifications.tmx)
  $contact->setLang('en');
  //Specifies the path to the traslation file.
  $contact->setPathToTranslation('languages/w2_cf_notifications.tmx');
  //Specifies the default time zone.
  $contact->setDefaultTimeZone('America/New_York');
  //For SMTP sending - specify your own SMTP HOST (generally "smtp.domaine.com" - use "localhost" for Hosted Dedicated Server)
  $contact->setSmtpHost('localhost');
  //Sending email	 
  $contact->sendEmail();
  */
  
  

}
?>